%% CC BY-SA (Attribution-ShareAlike) Mamdani based neuro-fuzzy system with center-of-sets defuzzification 
%by Dr. Juan R. Castro of Universidad Autnoma de Baja California 
%is distributed under a Creative Commons Attribution-ShareAlike 4.0 International License 
%(https://creativecommons.org/licenses/by-sa/4.0/). 
%This license allows others to remix, retouch, and create from their work, even for commercial purposes, 
%as long as they give credit and license their new creations under the same terms. All new works based on 
%yours will carry the same license, so any derivative works will also allow commercial use.

function [SIGMA,CENTER,THETA] = fnngetm(fis)
% fnngetm.m
% Extrae los paramtros de funciones de membrecia gaussianas
n_in   = length(fis.input);   % n
n_out  = length(fis.output);  % m
n_rule = length(fis.rule);    % r
n_param_mf = 2;

SIGMA  = [];  % r x n
CENTER = [];  % r x n
for k=1:n_rule,
    index = fis.rule(k).antecedent;
    sigma  = [];
    center = [];
    for i=1:n_in,
        param = fis.input(i).mf(index(i)).params;
        sigma  = [sigma, param(1)];
        center = [center, param(2)];
    end
    SIGMA = [SIGMA; sigma];
    CENTER = [CENTER; center];
end

THETA = [];   % r x m
for j=1:n_out,
    out_Params{j} = reshape([fis.output(j).mf.params],1,n_rule);
    THETA = [THETA out_Params{j}(:)];
end
