%% CC BY-SA (Attribution-ShareAlike) Mamdani based neuro-fuzzy system with center-of-sets defuzzification 
%by Dr. Juan R. Castro of Universidad Autnoma de Baja California 
%is distributed under a Creative Commons Attribution-ShareAlike 4.0 International License 
%(https://creativecommons.org/licenses/by-sa/4.0/). 
%This license allows others to remix, retouch, and create from their work, even for commercial purposes, 
%as long as they give credit and license their new creations under the same terms. All new works based on 
%yours will carry the same license, so any derivative works will also allow commercial use.

function X = fnngetx(fis)
% FNNGETX Get all fis weight values as a single vector
n_in   = length(fis.input);   % n
n_out  = length(fis.output);  % m
n_rule = length(fis.rule);    % r
n_param_mf = 2;

SIGMA  = [];  % r x n
CENTER = [];  % r x n
for i=1:n_in,
    in_Params{i} = reshape([fis.input(i).mf.params],n_param_mf,n_rule)';
    SIGMA  = [SIGMA in_Params{i}(:,1)];
    CENTER = [CENTER in_Params{i}(:,2)];
end

THETA = [];   % r x m
for j=1:n_out,
    out_Params{j} = reshape([fis.output(j).mf.params],1,n_rule);
    THETA = [THETA out_Params{j}(:)];
end
X = [SIGMA(:); CENTER(:); THETA(:)];
