%% CC BY-SA (Attribution-ShareAlike) Mamdani based neuro-fuzzy system with center-of-sets defuzzification 
%by Dr. Juan R. Castro of Universidad Autnoma de Baja California 
%is distributed under a Creative Commons Attribution-ShareAlike 4.0 International License 
%(https://creativecommons.org/licenses/by-sa/4.0/). 
%This license allows others to remix, retouch, and create from their work, even for commercial purposes, 
%as long as they give credit and license their new creations under the same terms. All new works based on 
%yours will carry the same license, so any derivative works will also allow commercial use.

function fis = fnnsetm(fis,SIGMA,CENTER,THETA)
% fnnsetm.m
n_in  = length(fis.input);   % n
n_out = length(fis.output);  % m
n_rule = length(fis.rule);   % r

for i=1:n_in,
    for k=1:n_rule,
        fis.input(i).mf(k).params = [SIGMA(k,i) CENTER(k,i)];
    end
end

for j=1:n_out,
    theta = reshape(THETA(:,j),1,n_rule)';
    for k=1:n_rule,
        fis.output(j).mf(k).params = theta(k,:);
    end
end
